VERSION 5.00
Begin VB.Form frmPluginMain 
   Caption         =   "External Action"
   ClientHeight    =   3045
   ClientLeft      =   1350
   ClientTop       =   1845
   ClientWidth     =   4950
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3045
   ScaleWidth      =   4950
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdAbort 
      Caption         =   "Abbrechen"
      Height          =   375
      Left            =   3720
      TabIndex        =   5
      Top             =   2520
      Width           =   1095
   End
   Begin VB.ListBox lstCommands 
      Height          =   2790
      ItemData        =   "frmMain.frx":0000
      Left            =   120
      List            =   "frmMain.frx":0002
      TabIndex        =   4
      Top             =   120
      Width           =   3375
   End
   Begin VB.CommandButton cmdEdit 
      Caption         =   "Bearbeiten"
      Height          =   375
      Left            =   3720
      TabIndex        =   3
      Top             =   600
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   3720
      TabIndex        =   2
      Top             =   2040
      Width           =   1095
   End
   Begin VB.CommandButton cmdDel 
      Caption         =   "Lschen"
      Height          =   375
      Left            =   3720
      TabIndex        =   1
      Top             =   1080
      Width           =   1095
   End
   Begin VB.CommandButton cmdNew 
      Caption         =   "Neu"
      Height          =   375
      Left            =   3720
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "frmPluginMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************************************************
'* Copyright (C) 2010 Dennis Hermanns
'*
'*    This program is free software: you can redistribute it and/or modify
'*    it under the terms of the GNU General Public License as published by
'*    the Free Software Foundation, either version 3 of the License, or
'*    (at your option) any later version.
'*
'*    This program is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'*    GNU General Public License for more details.
'*
'*    You should have received a copy of the GNU General Public License
'*    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'***********************************************************************************************

Option Explicit

Implements IDMXCTool
Implements IExternalWindow
Implements ICommandServer

Public DS As New clsDS
Public CommandRef As clsCommand
Public INI As New clsIni

Private Sub SaveSettings()
    INI.Reset

    If DS.GetCount > 0 Then
        Dim Name As String
        Dim Action As String
        Dim Com As clsCommand
        Dim Param As Variant
        Dim i, j As Integer
                
        INI.SaveIni "General", "Count", DS.GetCount
        For i = 1 To DS.GetCount
            Action = "Action_" & Trim(i)
            Name = DS.GetName(i)
            Set Com = DS.GetByName(Name)
            INI.SaveIni Action, "Name", Name
            INI.SaveIni Action, "Path", Com.strPath
            INI.SaveIni Action, "ShowWindow", Com.ShowWindow
            INI.SaveIni Action, "BlackActivate", Com.BlackActivate
            INI.SaveIni Action, "BlackDeactivate", Com.BlackDeactivate
            INI.SaveIni Action, "BlackActivateParam", Com.BlackActivateParam
            INI.SaveIni Action, "BlackDeactivateParam", Com.BlackDeactivateParam
            INI.SaveIni Action, "ParamCount", Com.colParam.Count
            If Com.colParam.Count > 0 Then
                j = 1
                For Each Param In Com.colParam
                    INI.SaveIni Action, "Param_" & Trim(j), Com.colParam.Item(j)
                    j = j + 1
                Next Param
            End If
        Next i
    End If
End Sub

Private Sub LoadSettings()
    Dim Count As Integer
    Dim i, j As Integer
    Dim Action As String
    Dim ParamCount As Integer
    Dim Com As clsCommand
    
    Count = INI.GetIni("General", "Count", 0)
    If Count > 0 Then
        For i = 1 To Count
            Set Com = New clsCommand
            Action = "Action_" & Trim(i)
            Com.strName = INI.GetIni(Action, "Name", "Error")
            Com.strPath = INI.GetIni(Action, "Path", "Error")
            Com.ShowWindow = INI.GetIni(Action, "ShowWindow", 1)
            Com.BlackActivate = INI.GetIni(Action, "BlackActivate", 0)
            Com.BlackDeactivate = INI.GetIni(Action, "BlackDeactivate", 0)
            Com.BlackActivateParam = INI.GetIni(Action, "BlackActivateParam", "")
            Com.BlackDeactivateParam = INI.GetIni(Action, "BlackDeactivateParam", "")
            ParamCount = INI.GetIni(Action, "ParamCount", 0)
            If ParamCount > 0 Then
                For j = 1 To ParamCount
                    Com.colParam.Add INI.GetIni(Action, "Param_" & Trim(j), "Error")
                Next j
            End If
            DS.Add Com
            lstCommands.AddItem Com.strName
        Next i
    End If
End Sub

Private Sub cmdAbort_Click()
    Me.Hide
    Unload Me
End Sub

Private Sub cmdDel_Click()
    If lstCommands.ListIndex >= 0 Then
        DS.Delete lstCommands.List(lstCommands.ListIndex)
        lstCommands.RemoveItem lstCommands.ListIndex
    End If
End Sub

Private Sub cmdEdit_Click()
    If StrComp(lstCommands.Text, "", vbTextCompare) = 0 Then
        Exit Sub
    End If
    frmCommand.Edit = True
    Set CommandRef = DS.GetByName(lstCommands.Text)
    frmCommand.txtName = CommandRef.strName
    frmCommand.txtPath = CommandRef.strPath
    
    Select Case CommandRef.ShowWindow
        Case SW_HIDE: frmCommand.optHide = True
        Case SW_MINIMIZE: frmCommand.optMinimized = True
        Case SW_MAXIMIZE: frmCommand.optMaximized = True
        Case Else: frmCommand.optNormal = True
    End Select
    
    frmCommand.txtParam.Text = ""
    Dim Param As Variant
    For Each Param In CommandRef.colParam
        frmCommand.txtParam.Text = frmCommand.txtParam.Text + Param + vbCrLf
    Next Param
    frmCommand.txtParam.Text = Mid$(frmCommand.txtParam.Text, 1, Len(frmCommand.txtParam.Text) - Len(vbCrLf))
    If CommandRef.BlackActivate Then
        frmCommand.chkBlackActivate = vbChecked
        frmCommand.cboParamActivate.Enabled = True
    Else
        frmCommand.chkBlackActivate = vbUnchecked
    End If
    If CommandRef.BlackDeactivate Then
        frmCommand.chkBlackDeactivate = vbChecked
        frmCommand.cboParamDeactivate.Enabled = True
    Else
        frmCommand.chkBlackDeactivate = vbUnchecked
    End If
    frmCommand.cboParamActivate = CommandRef.BlackActivateParam
    frmCommand.cboParamDeactivate = CommandRef.BlackDeactivateParam
    frmCommand.Show vbModal
    If StrComp(CommandRef.strName, lstCommands.Text, vbTextCompare) <> 0 Then
        DS.Delete lstCommands.Text
        DS.Add CommandRef
        Dim idx As Integer
        idx = lstCommands.ListIndex
        lstCommands.RemoveItem idx
        lstCommands.AddItem CommandRef.strName, idx
    End If
End Sub

Private Sub cmdOK_Click()
    SaveSettings
    Me.Hide
End Sub

Private Function IDMXCTool_AskToSaveProjectData() As Boolean
'    Select Case MsgBox("nderungen speichern?", vbYesNoCancel + vbQuestion, "External Action")
'        Case vbcancel: IDMXCTool_AskToSaveProjectData = True
'        Case vbOK: SaveSettings
'    End Select
End Function

Private Sub IDMXCTool_ClearProjectData()
    Set DS = Nothing
    Set DS = New clsDS
End Sub

Private Sub IDMXCTool_LoadProjectData()
    LoadSettings
End Sub

Private Sub IDMXCTool_SaveProjectData()
    SaveSettings
End Sub

Private Property Let IDMXCTool_ViewMode(ByVal RHS As DMXCTypeLib.View)

End Property

Private Function IExternalWindow_hideWindow() As Boolean
    Me.Hide
End Function

Private Property Get IExternalWindow_isOpen() As Boolean
    Dim Frm As Form
    
    For Each Frm In Forms
        If StrComp(Frm.Name, Me.Name, vbTextCompare) = 0 Then
            IExternalWindow_isOpen = True
            Exit For
        End If
    Next
End Property


Private Function IExternalWindow_loadWindow() As Boolean
    Load Me
End Function

Private Function IExternalWindow_showWindow() As Boolean
    Me.Show
End Function


Private Function IExternalWindow_unloadWindow() As Boolean
    Unload Me
End Function

Private Property Let IExternalWindow_WindowState(RHS As Long)
    Me.WindowState = RHS
End Property

Private Property Get IExternalWindow_WindowState() As Long
    IExternalWindow_WindowState = Me.WindowState
End Property

Private Function ICommandServer_ExecuteCommand(FirstSelection As String, SecondSelection As String, NewValue As Long, Optional Stream As DMXCTypeLib.IDMXMixerChannel, Optional AdditionalData As PropertyBag) As Variant
    If NewValue = 100000 Then
        If FirstSelection <> "" Then
            Dim Com As clsCommand
            Dim Param As String
            
            Set Com = DS.GetByName(FirstSelection)
            If (Com.colParam.Count > 0) And (StrComp(SecondSelection, "", vbTextCompare) <> 0) And (StrComp(SecondSelection, "empty", vbTextCompare) <> 0) Then
                Param = SecondSelection
            End If
            Shell Com.strPath & " " & Param, Com.ShowWindow
        End If
    End If
End Function

Public Sub Blackout(ByVal Arg1 As Long)
    Dim i As Long
    
    For i = 1 To DS.GetCount
        Dim Com As clsCommand
        Set Com = DS.GetByIndex(i)
        If Arg1 = -1 Then
            If Com.BlackActivate Then
                Shell Com.strPath & " " & Com.BlackActivateParam, Com.ShowWindow
            End If
        ElseIf Arg1 = 0 Then
            If Com.BlackDeactivate Then
                Shell Com.strPath & " " & Com.BlackDeactivateParam, Com.ShowWindow
            End If
        End If
    Next i
End Sub

Private Function ICommandServer_GetFirstOptions() As DMXCTypeLib.IKeyCollection
    Set ICommandServer_GetFirstOptions = New KeyCollection
    With ICommandServer_GetFirstOptions
        Dim Count As Integer
        Dim Com As clsCommand
        Dim i As Integer
        Count = DS.GetCount
        If Count > 0 Then
            For i = 1 To Count
                Set Com = DS.GetByName(DS.GetName(i))
                .Add Com.strName, Com.strName
            Next i
        End If
    End With
End Function


Private Function ICommandServer_GetSecondOptions(FirstSelection As String) As DMXCTypeLib.IKeyCollection
    Set ICommandServer_GetSecondOptions = New KeyCollection
    With ICommandServer_GetSecondOptions
        Dim Com As clsCommand
        Dim Param As Variant
        Set Com = DS.GetByName(FirstSelection)
        If Com.colParam.Count > 0 Then
            .Add "", "empty"
            For Each Param In Com.colParam
                .Add Param, Param
            Next Param
        End If
    End With
End Function

Private Property Get ICommandServer_Name() As String
    ICommandServer_Name = "External Action"
End Property

Private Sub cmdNew_Click()
    Unload frmCommand
    Load frmCommand
    frmCommand.Edit = False
    Set CommandRef = New clsCommand
    frmCommand.Show vbModal
    DS.Add CommandRef
    lstCommands.AddItem CommandRef.strName
End Sub
